#include<iostream>
#include<string>
#include<cmath>
using namespace std;

main()
{
    char c1,c2;
    int a1,a2;
    cin>>c1;
    cin>>c2;
    cin>>a1;
    cin>>a2;
    string novi_str;
    
    if(a1>=1 && a1<=50000 && a2>=1 && a2<=50000)
    {
        if(abs(a1-a2)>1)
        {
        cout<<"Nemoguce";
        return 0;
        }
    }
    else
    return 0;
    if(c1==c2)
    {
        return 0;
    }
    if(a1>a2)
    {
        novi_str=c1;
        a1--;
        int zb=a1+a2;
        int i=0;
    while(i<zb)
    {
        if(i%2==0)
        {
        novi_str=novi_str+c2;
        a2--;
        }
        else if(i%2!=0)
        {
        novi_str=novi_str+c1;
        a1--;
        }
        i++;
    }
    }
    else if(a2>a1)
    {
        novi_str=c2;
        a2--;
        int zb=a1+a2;
        int i=0;
    while(i<zb)
    {
        if(i%2==0)
        {
        novi_str=novi_str+c1;
        a1--;
        }
        else if(i%2!=0)
        {
        novi_str=novi_str+c2;
        a2--;
        }
        
        i++;
    }
    }
    else if(a2==a1)
    {
    	novi_str="";
    	int zb=a1+a2;
        int i=0;
    while(i<zb)
    {
        if(i%2==0)
        {
        novi_str=novi_str+c1;
        a1--;
        }
        else if(i%2!=0)
        {
        novi_str=novi_str+c2;
        a2--;
        }
        
        i++;
    }
	}
    cout<<novi_str;
}